<?php
/*****************************************************************************
FozzyMail : Web based mail client created by Matthieu Fron
Copyright (C) 2003  Matthieu Fron

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

web site : http://fozzymail.mferon.com
web contact : fozzymail@mferon.com
******************************************************************************/
function encode($txt,$enc)
{
	switch($enc)
	{
		case "base64":
			$ret = chunk_split(base64_encode($txt));
			break;
		case "quoted printable":
			$ret = quoted_printable_encode($txt);
			break;
	}
	return($ret);
}
function quoted_printable_encode($txt)
{
	if (ereg("([\200-\377]|=\\?)", $txt))
	{
		$txt = str_replace("=", "=3D", $txt);
		$txt = str_replace("?", "=3F", $txt);
		$txt = str_replace("_", "=5F", $txt);
		$txt = str_replace(" ", "=20", $txt);
		for ($ch=127 ; $ch<=255 ; $ch++)
		{
			$txt     = str_replace(chr($ch), sprintf("=%02X", $ch), $txt);
		}
	}
	return($txt);
}
function header_quoted_encode($txt)
{
	if (ereg("([\200-\377]|=\\?)", $txt))
	{
		$txt = str_replace("=", "=3D", $txt);
		$txt = str_replace("?", "=3F", $txt);
		$txt = str_replace("_", "=5F", $txt);
		$txt = str_replace(" ", "=20", $txt);
		for ($ch=127 ; $ch<=255 ; $ch++)
		{
			$txt     = str_replace(chr($ch), sprintf("=%02X", $ch), $txt);
		}
		$txt = "=?iso-8859-1?Q?".$txt."?=";
	}
	return($txt);
}
class FozzyMail_mime
{
	var $headers;
	var $html;
	var $texte;
	var $attach;
	var $embedded;
	var $alternative;
	var $message_id;
	
	function FozzyMail_mime($headers,$texte="",$html="",$attach="",$priorite=3)
	{
		$this->message_id = "FOZZYMAIL_".md5(uniqid(time()));
		$this->headers = $headers;
		$this->headers[] = "X-Mailer: FozzyMail V1.0";
		$this->headers[] = "X-Priority: " . $priorite;
		$this->headers[] = "MIME-Version: 1.0";
		$this->headers[] = "Message-ID: " . $this->message_id;
		if (( $html == "" ) && ( $texte == "" )) 
			$this->add_texte(" ");
		else
		{
			$this->add_html($html);
			$this->add_texte($texte);
		}
		$this->attach = $attach;
		if (( $html != "" ) && ( $texte != "" )) $this->build_alternative(md5(uniqid(time())));
	}
	function build_alternative($bnd)
	{
		$bnd = "----=_FozzyMail_$bnd";
		$this->alternative = "Content-Type: multipart/alternative;\r\n\tboundary=\"$bnd\"\r\n\r\n--$bnd\r\n";
		$this->alternative .= $this->texte."--$bnd\r\n";
		$this->alternative .= $this->html."--$bnd--\r\n\r\n";
	}
	function add_texte($text)
	{
		if ( $text != "" )
		{
			$this->texte =  "Content-Type: text/plain;\r\n\tcharset=\"iso-8859-1\"\r\n";
			$this->texte .= "Content-Transfer-Encoding: quoted-printable\r\n\r\n";
			if ( !ereg("\r\n$",$text) ) 
				$this->texte .= encode($text,"quoted printable")."\r\n\r\n";
			else
				$this->texte .= encode($text,"quoted printable")."\r\n";
		}
	}
	function add_html($text)
	{
		if ( $text != "" )
		{
			$this->html =  "Content-Type: text/html;\r\n\tcharset=\"iso-8859-1\"\r\n";
			$this->html .= "Content-Transfer-Encoding: quoted-printable\r\n\r\n"; 
			if ( !ereg("\r\n$",$text) ) 
				$this->html .= encode($text,"quoted printable")."\r\n\r\n";
			else
				$this->html .= encode($text,"quoted printable")."\r\n";
		}
	}
	function add_attach($path,$name,$fp)
	{
		ereg(".*\.([a-z]{3,4})$",$name,$regs);
		$ext = strtolower($regs[1]);
		if ( $ext == "gif" ) 
			fwrite($fp,"Content-Type: image/gif;\r\n\tname=\"".$name."\"\r\n");
		else if (( $ext == "jpg" )  || ( $ext == "jpeg" )  || ( $ext == "jpe" ))
			fwrite($fp,"Content-Type: image/jpeg;\r\n\tname=\"".$name."\"\r\n");
		else if ( $ext == "png" )
			fwrite($fp,"Content-Type: image/png;\r\n\tname=\"".$name."\"\r\n");
		else if ( $ext == "bmp" )
			fwrite($fp,"Content-Type: image/bmp;\r\n\tname=\"".$name."\"\r\n");
		else
			fwrite($fp,"Content-Type: application/octet-stream;\r\n\tname=\"".$name."\"\r\n");
		fwrite($fp,"Content-Transfer-Encoding: base64\r\n");
		fwrite($fp,"Content-Disposition: attachment;\r\n\tfilename=\"".$name."\"\r\n\r\n");  
		if ( ($fg=fopen($path.$name,"r")) != false )
		{
			$enc="";
			while( !feof($fg) )
			{
				fwrite($fp,chunk_split(base64_encode(fread($fg,201000))));
			}
			fclose($fg);
		}
		else
			die("erreur fichier");
	}
	function make_file_mail($us_dir)
	{
		$boundary="";
		if ( ($fp = fopen($us_dir."tmp/sendemail.txt","w")) != false )
		{
			if ( is_array($this->attach) )
			{
				$boundary = "----=_FozzyMail_".md5(uniqid(time()));
				$this->headers[] = "Content-Type: multipart/mixed;\r\n\tboundary=\"".$boundary."\"";
			}
			foreach($this->headers as $lig)
			{
				fwrite($fp,$lig."\r\n");
			}
			if ( $boundary != "" )
			{
				fwrite($fp, "\r\n--".$boundary."\r\n");
			}
			if ( $this->alternative != "" )
				fwrite($fp, $this->alternative);
			else if ( $this->html != "" )
				fwrite($fp, $this->html);
			else
				fwrite($fp, $this->texte);
			if ( is_array($this->attach ) )
			{
				foreach($this->attach as $fl)
				{
					fwrite($fp, "--".$boundary."\r\n");
					$this->add_attach($us_dir."tmp/",$fl,$fp);
				}
			}
			if ( $boundary != "" )
			{
				fwrite($fp, "--".$boundary."--\r\n\r\n");
			}
			fwrite($fp,".\r\n");
			fclose($fp);
		}
	}
	function send_file_mail($smtp_srv,$smtp_port,$from,$to,$us_dir)
	{
		$ret=false;
		$connection = fsockopen ($smtp_srv, $smtp_port, &$errno, &$errstr, 15);

		if (!$connection) 
		{
			echo "$errstr ($errno)<br>\n";
		} 
		else 
		{
			if ( ($fp = fopen($us_dir."tmp/sendemail.txt","r")) != false )
			{
				$res1=fgets($connection,256);
				fputs($connection, "HELO localhost\r\n");
				$res2=fgets($connection,256);
				fputs($connection, "MAIL FROM: $from\r\n");
				$res3=fgets($connection,256);
				foreach($to as $rcpt)
				{
					//echo "envoi :$rcpt\r\n";
					fputs($connection, "RCPT TO: $rcpt\r\n");
					fgets($connection,256);
				}
				fputs($connection, "DATA\r\n");
				$res5=fgets($connection,256);
				while( !feof($fp) )
				{
					fputs($connection, fread($fp,4096));
				}					
				$res6=fgets($connection,256);
				fputs($connection,"QUIT\r\n");
				$res7=fgets($connection,256);
				fclose ($fp);
				if(substr($res1,0,3) == "220" && substr($res2,0,3) == "250" && substr($res3,0,3) == "250" && substr($res5,0,3) == "354" && substr($res6,0,3) == "250" && substr($res7,0,3) == "221") 
				{
					$ret=true;
				}
				else
				{
					echo $res1."<br>".$res2."<br>".$res3."<br>".$res4."<br>".$res5."<br>".$res6."<br>".$res7;				
				}
				//	echo $res1."<br>".$res2."<br>".$res3."<br>".$res4."<br>".$res5."<br>".$res6."<br>".$res7;				
			}
			fclose ($connection);
		}
		return($ret);
	}
}
?>